# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Name:		perl-Archive-Zip
Version:	1.30
Release:	6.%{__distinit}%{__distvers}
Summary:	Perl library for accessing Zip archives
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Archive-Zip/
Source0:	http://search.cpan.org/CPAN/authors/id/A/AD/ADAMK/Archive-Zip-%{version}.tar.gz
Patch0:		Archive-Zip-1.30-minversion.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Compress::Raw::Zlib) >= 2.017
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::CPAN::Meta)
# Test::MinimumVersion -> Perl::MinimumVersion -> Perl::Critic ->
# various dependencies including PPIx::Regexp and Exception::Class ->
# Test::Kwalitee -> Module::CPANTS::Analyse -> Archive::Any -> Archive::Zip
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Test::MinimumVersion)
%endif
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	unzip
BuildRequires:	zip
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Kludge to remove bogus perl(NedsFileHandle) provide (rpm 4.9 onwards)
%global __provides_exclude ^perl\\(NedsFileHandle\\)

%description
The Archive::Zip module allows a Perl program to create, manipulate,
read, and write Zip archive files.

Zip archives can be created, or you can read from existing zip files.
Once created, they can be written to files, streams, or strings.
Members can be added, removed, extracted, replaced, rearranged, and
enumerated.  They can also be renamed or have their dates, comments,
or other attributes queried or modified.  Their data can be compressed
or uncompressed as needed. Members can be created from members in
existing Zip files, or from existing directories, files, or strings.

%prep
%setup -q -n Archive-Zip-%{version}

# Fix test failure with Perl::MinimumVersion ≥ 1.22 (CPAN RT#52696)
%patch0 -p0

# Fix script interpreters
perl -pi -e 's|^#!/bin/perl|#!/usr/bin/perl|' examples/*.pl
perl -pi -e 's|^#!/usr/local/bin/perl|#!/usr/bin/perl|' examples/selfex.pl

# Kludge to remove bogus perl(NedsFileHandle) provide (prior to rpm 4.9)
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Fvx 'perl(NedsFileHandle)'"
%define __perl_provides %{provfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

%check
make test AUTOMATED_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README examples/
%{_bindir}/crc32
%dir %{perl_vendorlib}/Archive/
%dir %{perl_vendorlib}/Archive/Zip/
%{perl_vendorlib}/Archive/Zip.pm
%{perl_vendorlib}/Archive/Zip/Archive.pm
%{perl_vendorlib}/Archive/Zip/BufferedFileHandle.pm
%{perl_vendorlib}/Archive/Zip/DirectoryMember.pm
%{perl_vendorlib}/Archive/Zip/FileMember.pm
%{perl_vendorlib}/Archive/Zip/Member.pm
%{perl_vendorlib}/Archive/Zip/MemberRead.pm
%{perl_vendorlib}/Archive/Zip/MockFileHandle.pm
%{perl_vendorlib}/Archive/Zip/NewFileMember.pm
%{perl_vendorlib}/Archive/Zip/StringMember.pm
%{perl_vendorlib}/Archive/Zip/Tree.pm
%{perl_vendorlib}/Archive/Zip/ZipFileMember.pm
%doc %{perl_vendorlib}/Archive/Zip/FAQ.pod
%{_mandir}/man3/Archive::Zip.3pm*
%{_mandir}/man3/Archive::Zip::FAQ.3pm*
%{_mandir}/man3/Archive::Zip::MemberRead.3pm*
%{_mandir}/man3/Archive::Zip::Tree.3pm*

%changelog
* Wed Feb  8 2012 Paul Howarth <paul@city-fan.org> - 1.30-6
- Don't BR: perl(Test::MinimumVersion) if we're bootstrapping
- Tweak fix for CPAN RT#52696 to require perl 5.005 since Archive::Zip uses
  the $! variable

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 1.30-5
- Rebuild for perl 5.14.1 in Rawhide
- Fix provides filter to work with rpm 4.9 onwards
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 1.30-4
- Rebuild for perl 5.12.1 in Rawhide

* Tue Jun  8 2010 Paul Howarth <paul@city-fan.org> - 1.30-3
- Fix dist tag for RHEL-6 Beta

* Fri Feb 12 2010 Paul Howarth <paul@city-fan.org> - 1.30-2
- Add upstream fix for 99_pmv.t test failure (CPAN RT#52696)
- Filter bogus provide of perl(NedsFileHandle)
- Dist tag for Rawhide no longer needs special-casing

* Tue Jun 30 2009 Paul Howarth <paul@city-fan.org> - 1.30-1
- Update to 1.30 (fix CPAN RT#47454 - Cwd::getcwd issue)
- Cwd::getcwd patch no longer needed

* Tue Jun 30 2009 Paul Howarth <paul@city-fan.org> - 1.29-1
- Update to 1.29 (fix CPAN RT#47223)
- Patch Zip.pm to call Cwd::getcwd in a more portable way

* Wed Jun 17 2009 Paul Howarth <paul@city-fan.org> - 1.28-1
- Update to 1.28 (many improvements and bugfixes - see Changes file)
- BR: Compress::Raw::Zlib rather than Compress::Zlib
- Mark FAQ.pod as %%doc

* Thu May  7 2009 Paul Howarth <paul@city-fan.org> - 1.26-1
- Import from Fedora
- Update to 1.26
- Drop File::Which buildreq, no longer needed
- Enable author tests in %%check
- Add buildreqs perl(Test::CPAN::Meta), perl(Test::MinimumVersion),
  perl(Test::Pod)

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri May 16 2008 Steven Pritchard <steve@kspei.com> 1.23-1
- Update to 1.23.

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.20-5
- Rebuild for perl 5.10 (again)

* Fri Jan 11 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.20-4
- rebuild for new perl

* Mon Aug 23 2007 Robin Norwood <rnorwood@redhat.com> - 1.20-3
- Fix license tag

* Wed Jun 27 2007 Robin Norwood <rnorwood@redhat.com> - 1.20-2
- Resolves: rhbz#226240
- Incorporate changes from Steven Pritchard's package review
- Fix find option order.
- Use fixperms macro instead of our own chmod incantation.
- Remove check macro cruft.
- Update build dependencies.
- Package LICENSE.
- BR unzip, zip for better test coverage.

* Tue Jun 05 2007 Robin Norwood <rnorwood@redhat.com> - 1.20-1
- Update to latest CPAN version: 1.20
- Fix broken changelog

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1.16-1.2.1
- rebuild

* Fri Feb 03 2006 Jason Vas Dias<jvdias@redhat.com> - 1.16-1.2
- rebuilt for new perl-5.8.8

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcc

* Mon Jul 11 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.16-1
- Update to 1.16.

* Thu Apr 14 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.14-1
- Update to 1.14.

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Sun Aug 15 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.12-0.fdr.1
- Update to 1.12.

* Tue Jul  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.11-0.fdr.1
- Update to 1.11.
- Bring up to date with current fedora.us Perl spec template.

* Sun Apr 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.10-0.fdr.1
- Update to 1.10.
- Reduce directory ownership bloat.
- Require perl(:MODULE_COMPAT_*).

* Fri Nov 28 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.09-0.fdr.1
- Update to 1.09.

* Wed Oct 22 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.08-0.fdr.1
- Update to 1.08.

* Tue Oct 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.07-0.fdr.1
- Update to 1.07.

* Sun Sep 14 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.06-0.fdr.1
- Update to 1.06.
- Specfile cleanups.

* Sun Jun  8 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.05-0.fdr.1
- First build.
